<script setup lang="ts">
import AddButton from "@/components/organisms/button/AddButton.vue";
import Flex from "@/components/atoms/container/Flex.vue";
import PatchNoteSection from "@/entities/MergeRequest/PatchNoteSection";
import {computed, ComputedRef, nextTick, onMounted, ref, watch} from "vue";
import {findShortcutWithCode} from "@/constants/SHORTCUTS_PER_SECTION";
import ContentSection from "@/components/organisms/section/MergeRequest/ContentSection.vue";
import {useShortcutsListenerStore} from "@/stores/Shortcuts/ShortcutsListenerStore";
import type Shortcut from "@/entities/Shortcut/Shortcut";
import ShortcutText from "@/components/atoms/text/shorcut/ShortcutText.vue";
import TextContainer from "@/components/atoms/container/TextContainer.vue";

const props = defineProps<{
  section: PatchNoteSection,
  hasFocus: Boolean,
  disabled?: undefined|Boolean
}>()

const shortcutsListener = useShortcutsListenerStore();

const root: ref<HTMLElement> = ref(null);

const addContent = () => {
  props.section?.addContent('');
  focusLastContent();
}

const getContentList = () => root.value.querySelectorAll('textarea');

const focusLastContent = () => {
  nextTick(() => {
    const textareaList = getContentList();
    textareaList[textareaList.length - 1]?.focus();
  });
};

const focusContentWithIndex = (index: Number) => {
  nextTick(() => {
    const textareaList = getContentList();
    textareaList[index]?.focus();
  });
};

const moveContentLine = (index: Number, up: Boolean) => {
  const newIndex = up ? index - 1 : index + 1;
  props.section?.swapContentLines(index, newIndex);
  focusContentWithIndex(newIndex);
}

const shortcut: ComputedRef<Shortcut | null> = computed(() => {
  return findShortcutWithCode(props.section?.code);
})

const focusOnSection = (event: KeyboardEvent) => {
  if (!shortcut.value?.isValidEvent(event)) {
    return;
  }

  event.preventDefault();

  if (props.section?.content?.length > 0) {
    focusContentWithIndex(0);
  } else {
    addContent();
  }
}

const addShortcutEventListener = () => {
  if (shortcut.value) {
    if (props.hasFocus) {
      shortcutsListener.addListener(focusOnSection)
    } else {
      shortcutsListener.removeListener(focusOnSection)
    }
  }
}

watch(() => props.hasFocus, addShortcutEventListener)

onMounted(addShortcutEventListener)
</script>

<template>
  <div ref="root">
    <Flex class="flex-col gap-text">
      <TextContainer class="items-center font-bold">
        <span>##</span>
        <span v-if="disabled">{{ section.name }}</span>
        <ShortcutText v-if="!disabled" :shortcut="shortcut?.toString()">{{ section.name }}</ShortcutText>
        <AddButton v-if="!disabled" @click="addContent"/>
      </TextContainer>
      <ContentSection
          :content="contentLine"
          :key="'content_' + index" v-for="(contentLine, index) of section?.content"
          :addContentFunction="addContent"
          :goToPreviousContent="() => focusContentWithIndex(index - 1)"
          :goToNextContent="() => focusContentWithIndex(index + 1)"
          :moveUpContentLine="() => moveContentLine(index, true)"
          :moveDownContentLine="() => moveContentLine(index, false)"
          :onRemove="() => {
            section?.removeContentAtIndex(index);
            if(index + 1 < section?.content.length){
              focusContentWithIndex(index);
            } else {
              focusLastContent();
            }
          }"
          :onInput="(newContent: String) => {
            section?.setContentAtIndex(index, newContent);
          }"
          :disabled="disabled"
      />
    </Flex>
  </div>
</template>